Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcnam.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcnam.F90	(revision 2038)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcnam.F90	(revision 2038)
@@ -0,0 +1,203 @@
+MODULE trcnam
+   !!======================================================================
+   !!                       ***  MODULE trcnam  ***
+   !! TOP :   Read and print options for the passive tracer run (namelist)
+   !!======================================================================
+   !! History :    -   !  1996-11  (M.A. Foujols, M. Levy)  original code
+   !!              -   !  1998-04  (M.A Foujols, L. Bopp) ahtrb0 for isopycnal mixing
+   !!              -   !  1999-10  (M.A. Foujols, M. Levy) separation of sms
+   !!              -   !  2000-07  (A. Estublier) add TVD and MUSCL : Tests on ndttrc
+   !!              -   !  2000-11  (M.A Foujols, E Kestenare) trcrat, ahtrc0 and aeivtr0
+   !!              -   !  2001-01 (E Kestenare) suppress ndttrc=1 for CEN2 and TVD schemes
+   !!             1.0  !  2005-03 (O. Aumont, A. El Moussaoui) F90
+   !!----------------------------------------------------------------------
+#if defined key_top
+   !!----------------------------------------------------------------------
+   !!   'key_top'                                                TOP models
+   !!----------------------------------------------------------------------
+   !!   trc_nam    :  Read and print options for the passive tracer run (namelist)
+   !!----------------------------------------------------------------------
+   USE oce_trc
+   USE trc
+   USE trcnam_trp        ! Transport namelist
+   USE trcnam_lobster    ! LOBSTER namelist
+   USE trcnam_pisces     ! PISCES namelist
+   USE trcnam_cfc        ! CFC SMS namelist
+   USE trcnam_c14b       ! C14 SMS namelist
+   USE trcnam_my_trc     ! MY_TRC SMS namelist
+   USE in_out_manager    ! I/O manager
+   USE trdmod_trc_oce
+
+   IMPLICIT NONE
+   PRIVATE 
+
+   PUBLIC trc_nam      ! called in trcini
+
+   !! * Substitutions
+#  include "top_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 1.0 , LOCEAN-IPSL (2005) 
+   !! $Id: trclec.F90 1581 2009-08-05 14:53:12Z smasson $ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE trc_nam
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_nam  ***
+      !!
+      !! ** Purpose :   READ and PRINT options for the passive tracer run (namelist) 
+      !!
+      !! ** Method  : - read passive tracer namelist 
+      !!              - read namelist of each defined SMS model
+      !!                ( (LOBSTER, PISCES, CFC, MY_TRC )
+      !!---------------------------------------------------------------------
+      INTEGER ::  jn
+
+      ! Definition of a tracer as a structure
+      TYPE PTRACER
+         CHARACTER(len = 20)  :: clsname  !: short name
+         CHARACTER(len = 80 ) :: cllname  !: long name
+         CHARACTER(len = 20 ) :: clunit   !: unit
+         LOGICAL              :: llinit   !: read in a file or not
+         LOGICAL              :: llsave   !: save the tracer or not
+      END TYPE PTRACER
+
+      TYPE(PTRACER) , DIMENSION(jptra) :: sn_tracer
+
+      !!
+      NAMELIST/namtrc/    nn_dttrc, nn_writetrc, ln_rsttr, nn_rsttr, &
+                          cn_trcrst_in, cn_trcrst_out, sn_tracer
+#if defined key_trdmld_trc  || defined key_trdtrc
+      NAMELIST/namtrc_trd/ nn_trd_trc, nn_ctls_trc, rn_ucf_trc, &
+                         ln_trdmld_trc_restart, ln_trdmld_trc_instant, &
+                         cn_trdrst_trc_in, cn_trdrst_trc_out, ln_trdtrc
+#endif
+
+      !!---------------------------------------------------------------------
+
+      IF(lwp) WRITE(numout,*) 'trc_nam : read the passive tracer namelists'
+      IF(lwp) WRITE(numout,*) '~~~~~~~'
+
+      CALL ctl_opn( numnat, 'namelist_top', 'OLD', 'FORMATTED', 'SEQUENTIAL', 1, numout, .FALSE. )
+
+      ! Namelist nattrc (files)
+      ! ----------------------------------------------
+      nn_dttrc    = 1                 ! default values
+      nn_writetrc = 10      
+      ln_rsttr    = .FALSE.
+      nn_rsttr    =  0
+      cn_trcrst_in  = 'restart_trc'
+      cn_trcrst_out = 'restart_trc'
+      DO jn = 1, jptra
+         WRITE(ctrcnm(jn),'("TR_",I1)'           ) jn
+         WRITE(ctrcnl(jn),'("TRACER NUMBER ",I1)') jn
+         ctrcun(jn) = 'mmole/m3'
+         lutini(jn) = .FALSE. 
+         lutsav(jn) = .TRUE. 
+      END DO
+
+      REWIND( numnat )               ! read nattrc
+      READ  ( numnat, namtrc )
+
+      !!Chris  computes the first time step of tracer model
+      nittrc000 = nit000 + nn_dttrc - 1
+
+      DO jn = 1, jptra
+         ctrcnm(jn) = sn_tracer(jn)%clsname
+         ctrcnl(jn) = sn_tracer(jn)%cllname
+         ctrcun(jn) = sn_tracer(jn)%clunit
+         lutini(jn) = sn_tracer(jn)%llinit
+         lutsav(jn) = sn_tracer(jn)%llsave
+      END DO
+
+
+      IF(lwp) THEN                   ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : namtrc'
+         WRITE(numout,*) '    time step freq. for pass. trac. nn_dttrc             = ', nn_dttrc
+         WRITE(numout,*) '    1st time step for pass. trac. nittrc000              = ', nittrc000
+         WRITE(numout,*) '    frequency of outputs for passive tracers nn_writetrc = ', nn_writetrc  
+         WRITE(numout,*) '    restart LOGICAL for passive tr. ln_rsttr             = ', ln_rsttr
+         WRITE(numout,*) '    control of time step for p. tr. nn_rsttr             = ', nn_rsttr
+         WRITE(numout,*) ' '
+         DO jn = 1, jptra
+            WRITE(numout,*) '   tracer nb             : ', jn 
+            WRITE(numout,*) '   short name            : ', TRIM(ctrcnm(jn))
+            WRITE(numout,*) '   long name             : ', TRIM(ctrcnl(jn))
+            WRITE(numout,*) '   unit                  : ', TRIM(ctrcun(jn))
+            WRITE(numout,*) '   initial value in FILE : ', lutini(jn) 
+            WRITE(numout,*) ' '
+         END DO
+      ENDIF
+
+#if defined key_trdmld_trc || defined key_trdtrc
+      nn_trd_trc  = 20
+      nn_ctls_trc =  9
+      rn_ucf_trc   =  1.
+      ln_trdmld_trc_instant = .TRUE.
+      ln_trdmld_trc_restart =.FALSE.
+      cn_trdrst_trc_in  = "restart_mld_trc"
+      cn_trdrst_trc_out = "restart_mld_trc"
+      ln_trdtrc(:) = .FALSE.
+
+      REWIND( numnat )               !  namelist namtoptrd : passive tracer trends diagnostic
+      READ  ( numnat, namtrc_trd )
+
+     IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) ' trd_mld_trc_init : read namelist namtrc_trd                    '
+         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~                                               '
+         WRITE(numout,*) '   * frequency of trends diagnostics   nn_trd_trc             = ', nn_trd_trc
+         WRITE(numout,*) '   * control surface type              nn_ctls_trc            = ', nn_ctls_trc
+         WRITE(numout,*) '   * restart for ML diagnostics        ln_trdmld_trc_restart  = ', ln_trdmld_trc_restart
+         WRITE(numout,*) '   * flag to diagnose trends of                                 '
+         WRITE(numout,*) '     instantantaneous or mean ML T/S   ln_trdmld_trc_instant  = ', ln_trdmld_trc_instant
+         WRITE(numout,*) '   * unit conversion factor            rn_ucf_trc             = ', rn_ucf_trc
+         DO jn = 1, jptra
+            IF( ln_trdtrc(jn) ) WRITE(numout,*) '    compute ML trends for tracer number :', jn
+         END DO
+      ENDIF
+#endif
+
+      ! namelist of transport
+      ! ---------------------
+      CALL trc_nam_trp
+
+
+      ! namelist of SMS
+      ! ---------------      
+      IF( lk_lobster ) THEN   ;   CALL trc_nam_lobster      ! LOBSTER bio-model
+      ELSE                    ;   IF(lwp) WRITE(numout,*) '          LOBSTER not used'
+      ENDIF
+
+      IF( lk_pisces  ) THEN   ;   CALL trc_nam_pisces      ! PISCES  bio-model
+      ELSE                    ;   IF(lwp) WRITE(numout,*) '          PISCES not used'
+      ENDIF
+
+      IF( lk_cfc     ) THEN   ;   CALL trc_nam_cfc         ! CFC     tracers
+      ELSE                    ;   IF(lwp) WRITE(numout,*) '          CFC not used'
+      ENDIF
+
+      IF( lk_c14b     ) THEN   ;   CALL trc_nam_c14b         ! C14 bomb     tracers
+      ELSE                    ;   IF(lwp) WRITE(numout,*) '          C14 not used'
+      ENDIF
+
+      IF( lk_my_trc  ) THEN   ;   CALL trc_nam_my_trc      ! MY_TRC  tracers
+      ELSE                    ;   IF(lwp) WRITE(numout,*) '          MY_TRC not used'
+      ENDIF
+      !
+   END SUBROUTINE trc_nam
+
+#else
+   !!----------------------------------------------------------------------
+   !!  Dummy module :                                     No passive tracer
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE trc_nam                      ! Empty routine   
+   END SUBROUTINE trc_nam
+#endif
+
+   !!======================================================================
+END MODULE  trcnam
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcrst.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcrst.F90	(revision 2038)
@@ -25,5 +25,5 @@
    USE oce_trc
    USE trc
-   USE trctrp_lec
+   USE trcnam_trp
    USE lib_mpp
    USE iom
@@ -33,5 +33,5 @@
    USE trcrst_c14b     ! C14 bomb restart
    USE trcrst_my_trc   ! MY_TRC   restart
-#if defined key_off_tra
+#if defined key_offline
     USE daymod
 #endif
@@ -67,5 +67,5 @@
       !!----------------------------------------------------------------------
       !
-# if ! defined key_off_tra
+# if ! defined key_offline
       IF( kt == nit000 ) lrst_trc = .FALSE. 
 # else
@@ -82,7 +82,7 @@
 # endif
      ! to get better performances with NetCDF format:
-     ! we open and define the tracer restart file one tracer time step before writing the data (-> at nitrst - 2*ndttrc + 1)
-     ! except if we write tracer restart files every tracer time step or if a tracer restart file was writen at nitend - 2*ndttrc + 1
-     IF( kt == nitrst - 2*ndttrc + 1 .OR. nstock == ndttrc .OR. ( kt == nitend - ndttrc + 1 .AND. .NOT. lrst_trc ) ) THEN
+     ! we open and define the tracer restart file one tracer time step before writing the data (-> at nitrst - 2*nn_dttrc + 1)
+     ! except if we write tracer restart files every tracer time step or if a tracer restart file was writen at nitend - 2*nn_dttrc + 1
+     IF( kt == nitrst - 2*nn_dttrc + 1 .OR. nstock == nn_dttrc .OR. ( kt == nitend - nn_dttrc + 1 .AND. .NOT. lrst_trc ) ) THEN
          ! beware of the format used to write kt (default is i8.8, that should be large enough)
          IF( nitrst > 1.0e9 ) THEN   ;   WRITE(clkt,*       ) nitrst
@@ -222,6 +222,6 @@
       !!
       !!   According to namelist parameter nrstdt,
-      !!       nrsttr = 0  no control on the date (nittrc000 is  arbitrary).
-      !!       nrsttr = 1  we verify that nit000 is equal to the last
+      !!       nn_rsttr = 0  no control on the date (nittrc000 is  arbitrary).
+      !!       nn_rsttr = 1  we verify that nit000 is equal to the last
       !!                   time step of previous run + 1.
       !!       In both those options, the  exact duration of the experiment
@@ -230,5 +230,5 @@
       !!       This is valid is the time step has remained constant.
       !!
-      !!       nrsttr = 2  the duration of the experiment in days (adatrj)
+      !!       nn_rsttr = 2  the duration of the experiment in days (adatrj)
       !!                    has been stored in the restart file.
       !!----------------------------------------------------------------------
@@ -237,5 +237,5 @@
       !
       REAL(wp) ::  zkt
-#if defined key_off_tra
+#if defined key_offline
       REAL(wp) ::  zndastp
 #endif
@@ -250,18 +250,18 @@
             WRITE(numout,*) '   previous time-step                               : ', NINT( zkt )
             WRITE(numout,*) ' *** restart option'
-            SELECT CASE ( nrsttr )
-            CASE ( 0 )   ;   WRITE(numout,*) ' nrsttr = 0 : no control of nittrc000'
-            CASE ( 1 )   ;   WRITE(numout,*) ' nrsttr = 1 : no control the date at nit000 (use ndate0 read in the namelist)'
-            CASE ( 2 )   ;   WRITE(numout,*) ' nrsttr = 2 : calendar parameters read in restart'
+            SELECT CASE ( nn_rsttr )
+            CASE ( 0 )   ;   WRITE(numout,*) ' nn_rsttr = 0 : no control of nittrc000'
+            CASE ( 1 )   ;   WRITE(numout,*) ' nn_rsttr = 1 : no control the date at nit000 (use ndate0 read in the namelist)'
+            CASE ( 2 )   ;   WRITE(numout,*) ' nn_rsttr = 2 : calendar parameters read in restart'
             END SELECT
             WRITE(numout,*)
          ENDIF
          ! Control of date 
-         IF( nittrc000  - NINT( zkt ) /= 1 .AND.  nrsttr /= 0 )                                  &
+         IF( nittrc000  - NINT( zkt ) /= 1 .AND.  nn_rsttr /= 0 )                                  &
             &   CALL ctl_stop( ' ===>>>> : problem with nit000 for the restart',                 &
-            &                  ' verify the restart file or rerun with nrsttr = 0 (namelist)' )
-#if defined key_off_tra
+            &                  ' verify the restart file or rerun with nn_rsttr = 0 (namelist)' )
+#if defined key_offline
          ! define ndastp and adatrj
-         IF ( nrsttr == 2 ) THEN
+         IF ( nn_rsttr == 2 ) THEN
             CALL iom_get( numrtr, 'ndastp', zndastp ) 
             ndastp = NINT( zndastp )
@@ -329,5 +329,5 @@
                DO ji = 1, jpi
                   zvol = cvol(ji,jj,jk)
-#  if defined key_off_degrad
+#  if defined key_degrad
                   zvol = zvol * facvol(ji,jj,jk)
 #  endif
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcsms.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcsms.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcsms.F90	(revision 2038)
@@ -48,5 +48,5 @@
       !!---------------------------------------------------------------------
 
-      IF ( MOD(kt,ndttrc) /= 0) RETURN      ! this ROUTINE is called only every ndttrc time step
+      IF ( MOD( kt, nn_dttrc) /= 0 ) RETURN      ! this ROUTINE is called only every ndttrc time step
 
       IF( lk_lobster )   CALL trc_sms_lobster( kt )    ! main program of LOBSTER
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcstp.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcstp.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcstp.F90	(revision 2038)
@@ -10,5 +10,5 @@
    !! * Modules used
    USE oce_trc          ! ocean dynamics and active tracers variables
-   USE trp_trc
+   USE trc
    USE trctrp           ! passive tracers transport
    USE trcsms           ! passive tracers sources and sinks
@@ -17,5 +17,5 @@
    USE trcwri
    USE trcrst
-   USE trdmld_trc_oce
+   USE trdmod_trc_oce
    USE trdmld_trc
    USE iom
@@ -52,6 +52,6 @@
       CHARACTER (len=25)    ::  charout
 
-      ! this ROUTINE is called only every ndttrc time step
-      IF( MOD( kt , ndttrc ) /= 0 ) RETURN
+      ! this ROUTINE is called only every nn_dttrc time step
+      IF( MOD( kt , nn_dttrc ) /= 0 ) RETURN
 
       IF(ln_ctl) THEN
@@ -59,4 +59,6 @@
          CALL prt_ctl_trc_info(charout)
       ENDIF
+
+      tra(:,:,:,:) = 0.
 
       IF( kt == nittrc000 .AND. lk_trdmld_trc  )  &
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcwri.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcwri.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcwri.F90	(revision 2038)
@@ -5,5 +5,4 @@
    !!====================================================================================
    !! History :   1.0  !  2009-05 (C. Ethe)  Original code
-   !!                  !  2010-03 (C. Ethe, R. Seferian ) Add the tracer transport trends
    !!----------------------------------------------------------------------
 #if defined key_top &&  defined key_iomput
@@ -12,13 +11,10 @@
    !!----------------------------------------------------------------------
    !! trc_wri_trc   :  outputs of concentration fields
-   !! trc_wri_trd   :  outputs of transport trends
    !!----------------------------------------------------------------------
    USE dom_oce         ! ocean space and time domain variables
    USE oce_trc
-   USE trp_trc
    USE trc
-   USE trdmld_trc_oce, ONLY : luttrd
    USE iom
-#if defined key_off_tra
+#if defined key_offline
    USE oce_trc
    USE dianam
@@ -50,7 +46,6 @@
 
       !
-      CALL iom_setkt  ( kt + ndttrc - 1 )       ! set the passive tracer time step
+      CALL iom_setkt  ( kt + nn_dttrc - 1 )       ! set the passive tracer time step
       CALL trc_wri_trc( kt              )       ! outputs for tracer concentration
-      CALL trc_wri_trd( kt              )       ! outputs for dynamical trends
       CALL iom_setkt  ( kt              )       ! set the model time step
       !
@@ -65,6 +60,6 @@
       INTEGER, INTENT( in ) :: kt       ! ocean time-step
       INTEGER               :: jn
-      CHARACTER (len=20)    :: cltra, cltras
-#if defined key_off_tra
+      CHARACTER (len=20)    :: cltra
+#if defined key_offline
       CHARACTER (len=40) :: clhstnam
       INTEGER ::   inum = 11            ! temporary logical unit
@@ -72,9 +67,9 @@
       !!---------------------------------------------------------------------
  
-#if defined key_off_tra
+#if defined key_offline
       IF( kt == nittrc000 ) THEN
         ! WRITE root name in date.file for use by postpro
          IF(lwp) THEN
-            CALL dia_nam( clhstnam, nwritetrc,' ' )
+            CALL dia_nam( clhstnam, nn_writetrc,' ' )
             CALL ctl_opn( inum, 'date.file', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp, narea )
             WRITE(inum,*) clhstnam
@@ -92,51 +87,4 @@
    END SUBROUTINE trc_wri_trc
 
-# if defined key_trc_diatrd
-
-   SUBROUTINE trc_wri_trd( kt )
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_wri_trd  ***
-      !!
-      !! ** Purpose :   output of passive tracer : advection-diffusion trends
-      !!
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt          ! ocean time-step
-      !!
-      CHARACTER (len=3) ::   cltra
-      INTEGER  ::   jn, jl, ikn
-      !!----------------------------------------------------------------------
-
-      DO jn = 1, jptra
-         IF( luttrd(jn) ) THEN
-            ikn = ikeep(jn)
-            DO jl = 1, jpdiatrc
-               IF( jl == jptrc_xad ) WRITE (cltra,"(3a)") 'XAD' ! x advection for tracer
-               IF( jl == jptrc_yad ) WRITE (cltra,"(3a)") 'YAD'  ! y advection for tracer
-               IF( jl == jptrc_zad ) WRITE (cltra,"(3a)") 'ZAD'  ! z advection for tracer
-               IF( jl == jptrc_xdf ) WRITE (cltra,"(3a)") 'XDF'  ! x diffusion for tracer
-               IF( jl == jptrc_ydf ) WRITE (cltra,"(3a)") 'YDF'  ! y diffusion for tracer
-               IF( jl == jptrc_zdf ) WRITE (cltra,"(3a)") 'ZDF'  ! z diffusion for tracer
-# if defined key_trcldf_eiv
-               IF( jl == jptrc_xei ) WRITE (cltra,"(3a)") 'XGV'  ! x gent velocity for tracer
-               IF( jl == jptrc_yei ) WRITE (cltra,"(3a)") 'YGV'  ! y gent velocity for tracer
-               IF( jl == jptrc_zei ) WRITE (cltra,"(3a)") 'ZGV'  ! z gent velocity for tracer
-# endif
-# if defined key_trcdmp
-               IF( jl == jptrc_dmp ) WRITE (cltra,"(3a)") 'DMP'  ! damping
-# endif
-               IF( jl == jptrc_sbc ) WRITE (cltra,"(3a)") 'SBC'  ! surface boundary conditions
-               ! write the trends
-               CALL iom_put( cltra, trtrd(:,:,:,ikn,jl) )
-            END DO
-         END IF
-      END DO
-      !
-   END SUBROUTINE trc_wri_trd
-
-# else
-   SUBROUTINE trc_wri_trd( kt )                      ! Dummy routine
-      INTEGER, INTENT ( in ) ::   kt
-   END SUBROUTINE trc_wri_trd
-#endif
 #else
    !!----------------------------------------------------------------------
